# -*- coding: iso-8859-1 -*-
hinweis="""
# Nach dem Vorschlag
# GK Aufgabenbeispiel 3 - [69 kB] - 27.07.2005
# inf-gk-aufgabe-3.pdf
# nach Python bertragen
#
# StD Dipl.-Inform. Dr. rer. nat. L. Humbert
# 20. August 2005
 ________________________________________________________________
/
| In der Aufgabenstellung befindet sich m.E. ein Fehler:
| Die Belegung von
| 110 1
| und
| 111 1
| 
| gelten nur fr den ersten Durchlauf 
| - anschlieend befindet sich in
| 110 4
| 
| Dies fhrt dazu, dass nicht
|  2^2 + 2^4 = 20
| sondern
|   2^2 + 2^(2+4) = 68
| ermittelt wird.
| 
| Daher weicht die hier vorliegende Lsung von der Musteraufgabe
| ab und enthlt die Zeilen
| 
|     speicher[118]="loadnum(1)"
|     speicher[119]="store(110)"
|     speicher[120]="store(111)"
|     speicher[121]="jump(100)"
|     
| Die Subroutine wird dann mit gosub(118)
| aktiviert.
| 
| L. Humbert    
\                
 ----------------------------------------------------------------
"""
global speicher
global bzr
global akku

speicher=[]
for bzr in range(128):
    speicher.append(0)
akku=0
bzr=0
akku=0
#--------------------

global inspektion
inspektion=True
inspektion=False

def speicherLeeren():
    global speicher, bzr
    for bzr in range(128):
        speicher[bzr]=0


# Aufgabenstellung -- Teil b    
# Die Speicherbelegung durch die 'Assembler'-Anweisungen wird mit Zeichenketten
# vorgenommen. Dadurch wird das 'Assembler'-Programm ausfhrbar.
# vgl. Funktion 'run(...)'
def Teil_b_Code():
    global speicher, bzr
    # belegt die Speicherzellen 111 und 113
    loadnum(3)
    store(111)
    loadnum(1)
    store(113)
    
    # Code wird in Speicherzellen 100 bis 110 abgelegt
    speicher[100]="load(113)"
    speicher[101]="store(112)"
    speicher[102]="load(111)"
    speicher[103]="jumpzero(110)"
    speicher[104]="subtract(113)"
    speicher[105]="store(111)"
    speicher[106]="load(112)"
    speicher[107]="add(112)"
    speicher[108]="store(112)"
    speicher[109]="jump(102)"
    speicher[110]="stop"
    # wird durch die ersten Anweisungen erreicht:
    # 3             # 111
    #               # 112
    # 1             # 113
    #               # 114
    bzr= 100


# Aufgabenstellung -- Teil f    
#
# Diese Lsung beseitigt den in der Aufgabenstellung befindlichen Fehler,
# um den in den Lsungshinweisen angegebenen Wert zu erhalten 
def Teil_f_Code():
    global akku, speicher, bzr
    # das ist falsch, da die Speicherzellen so nur einmal
    # vor dem ersten Durchgang belegt werden.
    # man htte vielleicht mal einen Informatiker fragen sollen ;-(
    # belegen die Speicherzellen 110 und 111
    loadnum(1)
    store(110)
    loadnum(1)
    store(111)

    # Code wird in Speicherzellen 89 bis 108 abgelegt
    speicher[ 89]="loadnum(2)"  # 2 ==> AKKU
    speicher[ 90]="store(109)"  # AKKU (2) ==> speicher[109] 
    # die folgende Zeile stammt aus der Vorgabe 
    # -- fhrt hier zum richtigen Zwischenergebnis
    #speicher[ 91]="gosub(100)"  #    Routine 100..108 ausfhren
    speicher[ 91]="gosub(118)"  #    Routine 100..108 ausfhren
    speicher[ 92]="load(110)"   # speicher[110] ==> AKKU (?)
    speicher[ 93]="store(112)"  # AKKU ==> speicher[112]
    speicher[ 94]="loadnum(4)"  # 4 ==> AKKU 
    speicher[ 95]="store(109)"  # AKKU (4) ==> speicher[109]
    # die folgende Zeile stammt aus der Vorgabe 
    # -- fhrt hier zum falschen Zwischenergebnis,
    # da die Speicherzelle 110 noch den Wert '4' enthlt
    #speicher[ 96]="gosub(100)"  #    Routine 100..108 ausfhren
    speicher[ 96]="gosub(118)"  #    Routine 118..121, 100..108 ausfhren
    speicher[ 97]="load(110)"   # speicher[110] ==> AKKU (?)
    speicher[ 98]="add(112)"    # AKKU (?) + speicher[112] ==> AKKU
    speicher[ 99]="stop"        # fettich

    # Hier beginnt das 'Unterprogramm', das mit GOSUB(100) 
    # ausgefhrt wird.
    speicher[100]="load(109)"               # speicher[109] ==>  AKKU (2|4)
    speicher[101]="jumpzero(108)"           # (AKKU == 0)?  bzr 108
    speicher[102]="subtract(111)"           # AKKU - 1 ==> AKKU
    speicher[103]="store(109)"              # AKKU ==> speicher[109] (1|3)
    speicher[104]="load(110)"               # speicher[110] (1) ==> AKKU
    speicher[105]="add(110)"                # AKKU + 1 ==> AKKU (2)
    speicher[106]="store(110)"              # AKKU (2) ==>  speicher[110] (2|2)
    speicher[107]="jump(100)"               
    speicher[108]="Return()"                  # zurck an Aufrufstelle + 1

    speicher[118]="loadnum(1)"
    speicher[119]="store(110)"
    speicher[120]="store(111)"
    speicher[121]="jump(100)"
    #
    # wird _nur_ durch die ersten Anweisungen erreicht
    # und verursacht so einen Fehler ...
    #           109
    #   1       110 
    #   1       111
    #           112
    bzr= 89


# Das 'Assemblerprogramm' wird ausgefhrt. Dabei
# beginnt das Programm die Abarbeitung in der durch 
# den Wert von'bzr' festgelegten Speicherstelle 
# 
# Als Parameter kann eine Liste von Elementen angegeben werden,
# deren Wert beim Auflauf protokolliert werden sollten.
# Die Ausgabe dieser Ergebnisse wird zeilenorientiert dargestellt.
def run(inspect=[]):
    global speicher, bzr, akku
    global inspektion
    while speicher[bzr]!="stop":
        for elem in inspect:            
            elemA=elem+":"
            print elemA,
            auswerten=eval(elem)
            if type(eval(elem)) != list:
                if type(auswerten) == int: 
                    auswerten=str(auswerten).rjust(3)+" "
            #else     
            print auswerten,

        eval(speicher[bzr])
        if len(inspect)!=0: print
        if inspektion:
            antwort= raw_input("[k]omplett|[a]kku|[b]zr|[s]peicher|<ret>")
            if antwort.upper()=="A": print akku
            elif antwort.upper()=="B": print bzr
            elif antwort.upper()=="S": print speicher
            elif antwort.upper()=="K": 
                print "\nAkku:\n",akku,"\nbzr:\n",bzr,"\nSpeicher:\n",speicher
                      

#Lade den Inhalt von Speicherzelle 'adresse' in den Akku
def load(adresse):
    global akku, bzr, speicher
    akku= speicher[adresse]
    bzr= bzr+1

# Schreibe den Inhalt des Akkus nach Speicherzelle 'adresse'
def store(adresse):
    global akku, bzr, speicher
    speicher[adresse]= akku
    bzr= bzr+1
    
# Fhre das Programm in 'adresse' fort, wenn im Akku der Wert 0
# vorliegt. Der Akkuinhalt bleibt erhalten.
def jumpzero(adresse):
    global akku, bzr
    if akku == 0:
        bzr= adresse
    else:
        bzr= bzr+1

# Subtrahiere vom Akku den Wert in Speicherzelle 'adresse'
def subtract(adresse):
    global akku, bzr, speicher
    akku= akku - speicher[adresse]
    bzr= bzr+1

# Addiere zum Akku den Wert in Speicherzelle 'adresse'
def add(adresse):
    global akku, bzr, speicher
    akku= akku + speicher[adresse]
    bzr= bzr+1

# Fhre das Programm in 'adresse' fort
def jump(adresse):
    global bzr
    bzr= adresse

# Schreibt 'konstante' in 'akku'
def loadnum(konstante=0):
    global akku, bzr
    akku= konstante
    bzr= bzr+1
    
# Trgt die 
# Rcksprungadresse - das ist die Adresse der Speicherzelle 
# nach dem GOSUB Befehl - in die Speicherzelle 127 ein.   
# Veranlasst einen Sprung zu dem Unterprogramm mit der 
# angegebenen Speicheradresse.
def gosub(adresse):
    global speicher, bzr
    speicher[127]= bzr+1
    jump(adresse) 

# Setzt das Programm an der Rcksprungadresse fort.
def Return():
    global speicher, bzr
    bzr= speicher[127]

def stop():
    print "fettich"


    

if __name__ == "__main__":
    print hinweis
    
    raw_input("Weiter mit Aufgabenteil b <ret>")

    print "Aufgabenteil b"
    print "=============="
    speicherLeeren()

    Teil_b_Code() # Programm wird in den Speicher geschrieben  
    print speicher
    # Programm wird ausgefhrt
    run(inspect=["bzr","akku","speicher[111:114]","speicher[bzr]"])
    print speicher
    print "Akku",akku
    print "bzr",bzr
    print "... gefragt war:"
    print "speicher[112]",speicher[112]
    
    speicherLeeren()
    
    raw_input("Weiter mit Aufgabenteil f <ret>")

    print "Aufgabenteil f"
    print "=============="
    speicherLeeren()

    Teil_f_Code() # Programm wird in den Speicher geschrieben  
    print speicher
    # Programm wird ausgefhrt
    run(inspect=["bzr","akku","speicher[109:113]","speicher[bzr]"])
    print speicher
    print "bzr",bzr
    print "... gefragt war:"
    print "Akku",akku
    


